Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.4.2-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Summary:        Java code generation framework
Name:           dynaop
Version:        1.0
Release:        alt2_0.beta.2jpp1.7
Epoch:          0
License:        Apache Software License, LGPL
URL:            https://dynaop.dev.java.net/
Group:          Development/Java
Source0:        https://dynaop.dev.java.net/files/documents/1189/2965/dynaop-1.0-beta-src.tar.bz2
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: asm >= 0:1.5.3
BuildRequires: bsh2
BuildRequires: cglib1
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-oro
BuildRequires: jetty5
BuildRequires: junit
BuildRequires: saxon
BuildRequires: servletapi5
Requires: jakarta-oro
Requires: cglib1
Requires: bsh2
Requires: asm >= 0:1.5.3
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
dynaop, a proxy-based Aspect-Oriented Programming (AOP) 
framework, enhances Object-Oriented (OO) design in the 
following areas:
* code reuse
* decomposition
* dependency reduction

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -c -q -n %{name}
for j in $(find . -name "*.jar"); do
      mv $j $j.no
done

#%patch0

%build
pushd lib
ln -sf $(build-classpath bsh2/bsh-classpath) .
ln -sf $(build-classpath bsh2/bsh-commands) .
ln -sf $(build-classpath bsh2/bsh-core) .
ln -sf $(build-classpath bsh2/bsh-reflect) .
ln -sf $(build-classpath bsh2/bsh-util) .
ln -sf $(build-classpath oro) .
ln -sf $(build-classpath cglib1) .
ln -sf $(build-classpath asm/asm) .
pushd build
ln -sf $(build-classpath saxon) .
ln -sf $(build-classpath servletapi5) .
ln -sf $(build-classpath jetty5/jetty5) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath commons-logging) .
popd
popd
ant dist test

%install

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/dist/%{name}-%{version}-beta.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/dist/manual/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p COPYING $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc %{_docdir}/%{name}-%{version}/COPYING
%{_javadir}/*.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}-%{version}

%changelog
* Wed Nov 12 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt2_0.beta.2jpp1.7
- force build with java4

* Tue Jul 24 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.beta.2jpp1.7
- converted from JPackage by jppimport script

